! WHIZARD <<Version>> <<Date>>
! 
! Copyright (C) 1999-2023 by 
!     Wolfgang Kilian <kilian@physik.uni-siegen.de>
!     Thorsten Ohl <ohl@physik.uni-wuerzburg.de>
!     Juergen Reuter <juergen.reuter@desy.de>
!     with contributions from
!     cf. main AUTHORS file
!
! WHIZARD is free software; you can redistribute it and/or modify it
! under the terms of the GNU General Public License as published by 
! the Free Software Foundation; either version 2, or (at your option)
! any later version.
!
! WHIZARD is distributed in the hope that it will be useful, but
! WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, write to the Free Software
! Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
module system_dependencies

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! All character strings indented by 7 blanks will be automatically
  ! split into chunks respecting the FORTRAN line length constraint by
  ! configure.
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  use, intrinsic :: omp_lib

  implicit none
  public
 
  ! Program version
  character(*), parameter :: WHIZARD_VERSION = "3.1.4"
  character(*), parameter :: WHIZARD_DATE = "Nov 08 2023"

  ! System paths
  ! These are used for testing without existing installation
  character(*), parameter :: WHIZARD_TEST_BASICS_MODPATH = &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/src/basics"
  character(*), parameter :: WHIZARD_TEST_UTILITIES_MODPATH = &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/src/utilities"
  character(*), parameter :: WHIZARD_TEST_COMBINATORICS_MODPATH = &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/src/combinatorics"
  character(*), parameter :: WHIZARD_TEST_SYSTEM_MODPATH = &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/src/system"
  character(*), parameter :: WHIZARD_TEST_PHYSICS_MODPATH = &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/src/physics"
  character(*), parameter :: WHIZARD_TEST_ME_MODPATH = &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/src/matrix_elements"
  character(*), parameter :: WHIZARD_TEST_MODELS_MODPATH = &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/src/models"
  character(*), parameter :: WHIZARD_TEST_THRESHOLD_MODPATH = &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/src/threshold"
  character(*), parameter :: WHIZARD_TEST_OMEGA_MODPATH = &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/omega/src"
  character(*), parameter :: WHIZARD_TEST_MAIN_LIBPATH = &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/src/main"
  character(*), parameter :: WHIZARD_TEST_OMEGA_BINPATH = &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/omega/bin"
  character(*), parameter :: WHIZARD_TEST_SRC_LIBPATH = &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/src"
  character(*), parameter :: WHIZARD_TEST_HEPMC_LIBPATH = &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/src/hepmc"
  character(*), parameter :: WHIZARD_TEST_LCIO_LIBPATH = &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/src/lcio"
  character(*), parameter :: WHIZARD_TEST_HOPPET_LIBPATH = &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/src/hoppet"
  character(*), parameter :: WHIZARD_TEST_LOOPTOOLS_LIBPATH = &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/src/looptools"
  character(*), parameter :: WHIZARD_TEST_MODELPATH = &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/share/models"
  character(*), parameter :: WHIZARD_TEST_MODELPATH_UFO = &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/share/models/UFO"
  character(*), parameter :: WHIZARD_TEST_MODELS_LIBPATH = &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/src/models"
  character(*), parameter :: WHIZARD_TEST_SUSYPATH = &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/share/susy"
  character(*), parameter :: WHIZARD_TEST_GMLPATH= &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/src/gamelan"
  character(*), parameter :: WHIZARD_TEST_CUTSPATH = &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/share/cuts"
  character(*), parameter :: WHIZARD_TEST_SHAREPATH = &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/share"
  character(*), parameter :: WHIZARD_TEST_TESTDATAPATH = &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/share/test"
  character(*), parameter :: WHIZARD_TEST_TEXPATH = &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/src/feynmf"
  character(*), parameter :: WHIZARD_TEST_CIRCE2PATH = &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/circe2/share/data"
  character(*), parameter :: WHIZARD_TEST_BEAMSIMPATH = &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/share/beam-sim"
  character(*), parameter :: WHIZARD_TEST_MULIPATH = &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/share/muli"
  character(*), parameter :: PDF_BUILTIN_TEST_DATAPATH = &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/share/pdf_builtin"

  ! WHIZARD-specific include flags
  character(*), parameter :: WHIZARD_TEST_INCLUDES = &
       "-I" // WHIZARD_TEST_MODELS_MODPATH // " " // &
       "-I" // WHIZARD_TEST_THRESHOLD_MODPATH // " " // &
       "-I" // WHIZARD_TEST_OMEGA_MODPATH // " " // &
       "-I" // WHIZARD_TEST_ME_MODPATH // " " // &
       "-I" // WHIZARD_TEST_PHYSICS_MODPATH // " " // &
       "-I" // WHIZARD_TEST_SYSTEM_MODPATH // " " // &
       "-I" // WHIZARD_TEST_COMBINATORICS_MODPATH // " " // &
       "-I" // WHIZARD_TEST_UTILITIES_MODPATH // " " // &
       "-I" // WHIZARD_TEST_BASICS_MODPATH // " " // &
       "-I/usr/lib64/openloops/lib_src/openloops/mod -I/usr/lib64/../include" 

  ! WHIZARD-specific link flags
  character(*), parameter :: WHIZARD_TEST_LDFLAGS = &
       "-L" // WHIZARD_TEST_MAIN_LIBPATH // " " // &
       "-L" // WHIZARD_TEST_SRC_LIBPATH // " " // &
       "-L" // WHIZARD_TEST_HEPMC_LIBPATH // " " // &
       "-L" // WHIZARD_TEST_LCIO_LIBPATH // " " // &
       "-L" // WHIZARD_TEST_HOPPET_LIBPATH // " " // &
       "-L" // WHIZARD_TEST_LOOPTOOLS_LIBPATH // " " // &
       "-lwhizard_main -lwhizard -lomega " // &
       "-I/usr/include/tirpc -ltirpc " // &
       "-Wl,-rpath,/usr/lib64 -L/usr/lib64 -lHepMC3  -llcio -L//usr/lib -L//usr/lib64 -lhoppet_v1 " // &
       "-L/usr/lib64 -looptools -Wl,-rpath,/usr/lib64/openloops/lib -L/usr/lib64/openloops/lib -Wl,-rpath,/usr/l&
       &ib64/openloops/lib64 -L/usr/lib64/openloops/lib64 -lopenloops " // &
       "-Wl,-rpath,/usr/lib64 -L/usr/lib64 -lrecola -lcollier"

  ! Libtool
  character(*), parameter :: WHIZARD_LIBTOOL_TEST = &
       "/builddir/build/BUILD/whizard-3.1.4-build/whizard-3.1.4/libtool"

  ! System paths
  ! These are used for the installed version
  character(*), parameter :: PREFIX = &
       "/usr"
  character(*), parameter :: EXEC_PREFIX = &
       "/usr"
  character(*), parameter :: BINDIR = &
       "/usr/bin"
  character(*), parameter :: LIBDIR = &
       "/usr/lib64"
  character(*), parameter :: INCLUDEDIR = &
       "/usr/include"
  character(*), parameter :: DATAROOTDIR = &
       "${prefix}/share"
  character(*), parameter :: FMODDIR = &
       "/usr/lib/mod"

  character(*), parameter :: PKGLIBDIR = LIBDIR  // "/whizard"
  character(*), parameter :: PKGDATADIR = DATAROOTDIR // "/whizard"
  character(*), parameter :: PKGTEXDIR = DATAROOTDIR // "/texmf/whizard"
  character(*), parameter :: PKGCIRCE2DIR = DATAROOTDIR // "/circe2"

  character(*), parameter :: WHIZARD_MODPATH = &
       FMODDIR // "/whizard"
  character(*), parameter :: OMEGA_MODPATH = &
       FMODDIR // "/omega"
  character(*), parameter :: MODELS_MODPATH = &
       FMODDIR // "/models"
  character(*), parameter :: WHIZARD_OMEGA_BINPATH = &
       BINDIR
  character(*), parameter :: WHIZARD_OMEGA_LIBPATH = &
       LIBDIR
  character(*), parameter :: WHIZARD_MODELPATH = &
       PKGDATADIR // "/models"
  character(*), parameter :: WHIZARD_MODELPATH_UFO = &
       PKGDATADIR // "/models/UFO"
  character(*), parameter :: WHIZARD_MODELS_LIBPATH = &
       PKGLIBDIR // "/models"
  character(*), parameter :: WHIZARD_SUSYPATH = &
       PKGDATADIR // "/susy"
  character(*), parameter :: WHIZARD_GMLPATH= &
       PKGLIBDIR // "/gamelan"
  character(*), parameter :: WHIZARD_SHAREPATH = &
       PKGDATADIR
  character(*), parameter :: WHIZARD_TESTDATAPATH = &
       PKGDATADIR // "/test"
  character(*), parameter :: WHIZARD_CUTSPATH = &
       PKGDATADIR // "/cuts"
  character(*), parameter :: WHIZARD_TEXPATH = &
       PKGTEXDIR
  character(*), parameter :: WHIZARD_CIRCE2PATH = &
       PKGCIRCE2DIR // "/data"
  character(*), parameter :: WHIZARD_BEAMSIMPATH = &
       PKGDATADIR // "/beam-sim"
  character(*), parameter :: WHIZARD_MULIPATH = &
       PKGDATADIR // "/muli"
  character(*), parameter :: PDF_BUILTIN_DATAPATH = &
       PKGDATADIR // "/pdf_builtin"

  ! WHIZARD-specific include flags
  character(*), parameter :: WHIZARD_INCLUDES = &
      "-I" // WHIZARD_MODPATH // " " // &
      "-I" // OMEGA_MODPATH // " " // &
      "-I" // MODELS_MODPATH // " " // &
       "-I/usr/lib64/openloops/lib_src/openloops/mod -I/usr/lib64/../include"

  ! WHIZARD-specific link flags
  character(*), parameter :: WHIZARD_LDFLAGS = &
      "-L" // WHIZARD_OMEGA_LIBPATH // " " // &
      "-lwhizard_main -lwhizard -lomega " // &
       "-I/usr/include/tirpc -ltirpc " // &
       "-Wl,-rpath,/usr/lib64 -L/usr/lib64 -lHepMC3  -llcio -L//usr/lib -L//usr/lib64 -lhoppet_v1 " // &
       "-L/usr/lib64 -looptools -Wl,-rpath,/usr/lib64/openloops/lib -L/usr/lib64/openloops/lib -Wl,-rpath,/usr/l&
       &ib64/openloops/lib64 -L/usr/lib64/openloops/lib64 -lopenloops " // &
       "-Wl,-rpath,/usr/lib64 -L/usr/lib64 -lrecola -lcollier"

  ! Libtool
  character(*), parameter :: WHIZARD_LIBTOOL = &
      PKGLIBDIR // "/libtool"


  ! Fortran compiler
  character(*), parameter :: DEFAULT_FC = &
       "gfortran"
  character(*), parameter :: DEFAULT_FCFLAGS = &
       " -fopenmp  -O2   -fexceptions -g -grecord-gcc-switches -pipe -Wall -Wno-complain-wrong-lang  -Wp,-U_FOR&
       &TIFY_SOURCE,-D_FORTIFY_SOURCE=3 -Wp,-D_GLIBCXX_ASSERTIONS  -fstack-protector-strong   -m64 -march=x86-64  -fasy&
       &nchronous-unwind-tables -fstack-clash-protection -fcf-protection -mtls-dialect=gnu2 -fno-omit-frame-pointer -mn&
       &o-omit-leaf-frame-pointer -Wno-error -fallow-argument-mismatch "
  character(*), parameter :: DEFAULT_FCFLAGS_PIC = &
       " -fPIC"
  character(*), parameter :: DEFAULT_FC_SRC_EXT = &
       ".f90"
  character(*), parameter :: DEFAULT_FC_PRECISION = &
       "double"
  character(*), parameter :: FCLIBS = &
       " -L/usr/lib/gcc/x86_64-redhat-linux/14 -L/usr/lib/gcc/x86_64-redhat-linux/14/../../../../lib64 -L/lib/.&
       &./lib64 -L/usr/lib/../lib64 -L/usr/lib/gcc/x86_64-redhat-linux/14/../../.. -lgfortran -lm -lquadmath"

  logical, parameter      :: OS_IS_DARWIN = .false.
  
  ! C compiler
  character(*), parameter :: DEFAULT_CC = &
       "gcc"
  character(*), parameter :: DEFAULT_CFLAGS = &
       "-O2   -fexceptions -g -grecord-gcc-switches -pipe -Wall -Wno-complain-wrong-lang  -Wp,-U_FORTIFY_SOURCE&
       &,-D_FORTIFY_SOURCE=3 -Wp,-D_GLIBCXX_ASSERTIONS  -fstack-protector-strong   -m64 -march=x86-64  -fasynchronous-u&
       &nwind-tables -fstack-clash-protection -fcf-protection -mtls-dialect=gnu2 -fno-omit-frame-pointer -mno-omit-leaf&
       &-frame-pointer -Wno-error -Wno-error=format-security "
  character(*), parameter :: DEFAULT_CFLAGS_PIC = &
       ""
  logical, parameter :: CC_IS_GNU = .true.
  logical, parameter :: CC_HAS_QUADMATH = .true.

  ! C++ compiler
  character(*), parameter :: DEFAULT_CXX = &
       "g++"
  character(*), parameter :: DEFAULT_CXXFLAGS = &
       "-O2   -fexceptions -g -grecord-gcc-switches -pipe -Wall -Wno-complain-wrong-lang  -Wp,-U_FORTIFY_SOURCE&
       &,-D_FORTIFY_SOURCE=3 -Wp,-D_GLIBCXX_ASSERTIONS  -fstack-protector-strong   -m64 -march=x86-64  -fasynchronous-u&
       &nwind-tables -fstack-clash-protection -fcf-protection -mtls-dialect=gnu2 -fno-omit-frame-pointer -mno-omit-leaf&
       &-frame-pointer -Wno-error -std=c++1z -Wno-error=format-security  -Wl,-rpath,/usr/lib -Wl,-rpath,/usr/lib64 -L/u&
       &sr/lib -L/usr/lib64 -lpythia8"
  character(*), parameter :: DEFAULT_CXXLIBS = &
       " -L/usr/lib/gcc/x86_64-redhat-linux/14 -L/usr/lib/gcc/x86_64-redhat-linux/14/../../../../lib64 -L/lib/.&
       &./lib64 -L/usr/lib/../lib64 -L/usr/lib/gcc/x86_64-redhat-linux/14/../../.. -lstdc++ -lm -lgcc_s"

  ! Object files
  character(*), parameter :: DEFAULT_OBJ_EXT = &
       ".o"

  ! Linker
  character(*), parameter :: DEFAULT_LD = &
       "/usr/bin/ld -m elf_x86_64"
  character(*), parameter :: DEFAULT_LDFLAGS = &
       ""
  character(*), parameter :: DEFAULT_LDFLAGS_SO = "-shared"
  character(*), parameter :: DEFAULT_LDFLAGS_STATIC = &
       "-lstdc++ -I/usr/include/tirpc -ltirpc"
  character(*), parameter :: DEFAULT_LDFLAGS_HEPMC = &
       "-Wl,-rpath,/usr/lib64 -L/usr/lib64 -lHepMC3 "
  character(*), parameter :: DEFAULT_LDFLAGS_LCIO = &
       "-llcio"
  character(*), parameter :: DEFAULT_LDFLAGS_HOPPET = &
       "-L//usr/lib -L//usr/lib64 -lhoppet_v1"
  character(*), parameter :: DEFAULT_LDFLAGS_LOOPTOOLS = &
       "-L/usr/lib64 -looptools"
  character(*), parameter :: DEFAULT_SHRLIB_EXT = "so"
  character(*), parameter :: DEFAULT_FC_SHRLIB_EXT = "so"

  ! Pack/unpack
  character(*), parameter :: DEFAULT_PACK_CMD = "tar -czf"
  character(*), parameter :: DEFAULT_UNPACK_CMD = "tar -xzf"
  character(*), parameter :: DEFAULT_PACK_EXT = ".tgz"

  ! Make
  character(*), parameter :: DEFAULT_MAKEFLAGS = &
       "-j1"

  ! LHAPDF library
  character(*), parameter :: LHAPDF_PDFSETS_PATH = &
       "/usr/share/LHAPDF"

  ! Available methods for event analysis display
  character(*), parameter :: EVENT_ANALYSIS = &
       "no"
  character(*), parameter :: EVENT_ANALYSIS_PS = &
       "no"
  character(*), parameter :: EVENT_ANALYSIS_PDF = &
       "no"

  ! Programs used for event analysis display
  character(*), parameter :: PRG_LATEX  = &
       "latex"
  character(*), parameter :: PRG_MPOST  = &
       "no"
  character(*), parameter :: PRG_DVIPS  = &
       "dvips"
  character(*), parameter :: PRG_PS2PDF = &
       "ps2pdf14"

  ! Programs and libraries used for NLO calculations
  ! GoSam
  character(*), parameter :: GOSAM_DIR = &
       "/usr"
  character(*), parameter :: GOLEM_DIR = &
       "/usr/lib64"
  character(*), parameter :: FORM_DIR = &
       "/usr"
  character(*), parameter :: QGRAF_DIR = &
       "/usr"
  character(*), parameter :: NINJA_DIR = &
       "/usr/lib64"
  character(*), parameter :: SAMURAI_DIR = &
       "/usr/lib64"

  ! OpenLoops
  character(*), parameter :: OPENLOOPS_DIR = &
       "/usr/lib64/openloops"
  character(*), parameter :: RECOLA_DIR = &
       "/usr/lib64"  

  ! Hardwired options for batch-mode processing
  character(*), parameter :: OPT_LATEX  = &
       "-halt-on-error"
  character(*), parameter :: OPT_MPOST  = &
       " -halt-on-error"

  ! dlopen parameters
  integer, parameter :: &
     RTLD_LAZY   = 1 , &
     RTLD_NOW    = 2 , &
     RTLD_GLOBAL = 256 , &
     RTLD_LOCAL  = 0

  ! Misc
  logical, parameter :: MPOST_AVAILABLE = .false.

  logical, parameter :: LHAPDF5_AVAILABLE = .false.
  logical, parameter :: LHAPDF6_AVAILABLE = .true.
  logical, parameter :: HEPMC2_AVAILABLE = .false.
  logical, parameter :: HEPMC3_AVAILABLE = .true.
  logical, parameter :: LCIO_AVAILABLE = "yes" == "yes"
  logical, parameter :: HOPPET_AVAILABLE = .true.

  logical, parameter :: PYTHIA6_AVAILABLE = .true.
  logical, parameter :: PYTHIA8_AVAILABLE = .true.

  logical, parameter :: GOSAM_AVAILABLE = .true.
  logical, parameter :: OPENLOOPS_AVAILABLE = .true.
  logical, parameter :: RECOLA_AVAILABLE = .true.  

contains

  ! Subroutines that depend on configure settings

  ! OpenMP wrapper routines, work independent of OpenMP status
  function openmp_is_active () result (flag)
    logical :: flag
    flag = .true.
!    flag = .false.
  end function openmp_is_active

  subroutine openmp_set_num_threads (num)
    integer, intent(in) :: num
    call omp_set_num_threads (num)
  end subroutine openmp_set_num_threads
  
  function openmp_get_num_threads () result (num)
    integer :: num
    num = omp_get_num_threads ()
!    num = 1
  end function openmp_get_num_threads
  
  function openmp_get_max_threads () result (num)
    integer :: num
    num = omp_get_max_threads ()
!    num = 1
  end function openmp_get_max_threads
  
  function openmp_get_default_max_threads () result (num)
    integer :: num
    num = 2
  end function openmp_get_default_max_threads

end module system_dependencies
